<!DOCTYPE html>
<html>
<head>
    <meta charset='utf-8'>
    <meta http-equiv='X-UA-Compatible' content='IE=edge'>
    <title>
        TO-DO List
    </title>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
</head>
<body>
    <script>

        const template = document.createElement('template');
        template.innerHTML = `
        <style>
            :host {
            display: block;
            font-family: sans-serif;
            text-align: center;
            }

            button {
            border: none;
            cursor: pointer;
            }

            ul {
            list-style: none;
            padding: 0;
            }
        </style>
        <h1>To do</h1>

        <input type="text" placeholder="Add a new to do"></input>
        <button>✅</button>

        <ul id="todos"></ul>
        `;

        class TodoApp extends HTMLElement {
            constructor() {
                super();
                this.addToList = this.addToList.bind(this);
                this._shadowRoot = this.attachShadow({ 'mode': 'open' });
                this._shadowRoot.appendChild(template.content.cloneNode(true));
                this.$todoList = this._shadowRoot.querySelector('ul');
                this.$input = this._shadowRoot.querySelector('input');
            }

            connectedCallback(){
                let buttonList = this.shadowRoot.querySelector('button');
                buttonList.addEventListener('click', this.addToList); 
            }
            
            deleteToList(e){
                e.target.parentNode.remove(e.target.parentNode);
            }

            addToList() {
                let li = document.createElement('li'),
                    button = document.createElement('button');
                button.textContent = `✅`;
                button.addEventListener('click', this.deleteToList);
                li.textContent = this.$input.value;
                li.appendChild(button);
                this.$todoList.appendChild(li);
                this.$input.value = '';
            }

            

        }

        window.customElements.define('to-do-app', TodoApp);


    </script>

    TODO List
    <to-do-app></to-do-app>
    
</body>
</html>